# /* Copyright (C) 2001
#  * Housemarque Oy
#  * http://www.housemarque.com
#  *
#  * Distributed under the Boost Software License, Version 1.0. (See
#  * accompanying file LICENSE_1_0.txt or copy at
#  * http://www.boost.org/LICENSE_1_0.txt)
#  */
#
# /* Revised by Paul Mensonides (2002) */
#
# /* See http://www.boost.org for most recent version. */
#
# ifndef SIMDPP_PREPROCESSOR_REPETITION_DETAIL_FOR_HPP
# define SIMDPP_PREPROCESSOR_REPETITION_DETAIL_FOR_HPP
#
# include <simdpp/detail/preprocessor/control/expr_iif.hpp>
# include <simdpp/detail/preprocessor/control/iif.hpp>
# include <simdpp/detail/preprocessor/logical/bool.hpp>
# include <simdpp/detail/preprocessor/tuple/eat.hpp>
#
# define SIMDPP_PP_FOR_1(s, p, o, m) SIMDPP_PP_FOR_1_C(SIMDPP_PP_BOOL(p(2, s)), s, p, o, m)
# define SIMDPP_PP_FOR_2(s, p, o, m) SIMDPP_PP_FOR_2_C(SIMDPP_PP_BOOL(p(3, s)), s, p, o, m)
# define SIMDPP_PP_FOR_3(s, p, o, m) SIMDPP_PP_FOR_3_C(SIMDPP_PP_BOOL(p(4, s)), s, p, o, m)
# define SIMDPP_PP_FOR_4(s, p, o, m) SIMDPP_PP_FOR_4_C(SIMDPP_PP_BOOL(p(5, s)), s, p, o, m)
# define SIMDPP_PP_FOR_5(s, p, o, m) SIMDPP_PP_FOR_5_C(SIMDPP_PP_BOOL(p(6, s)), s, p, o, m)
# define SIMDPP_PP_FOR_6(s, p, o, m) SIMDPP_PP_FOR_6_C(SIMDPP_PP_BOOL(p(7, s)), s, p, o, m)
# define SIMDPP_PP_FOR_7(s, p, o, m) SIMDPP_PP_FOR_7_C(SIMDPP_PP_BOOL(p(8, s)), s, p, o, m)
# define SIMDPP_PP_FOR_8(s, p, o, m) SIMDPP_PP_FOR_8_C(SIMDPP_PP_BOOL(p(9, s)), s, p, o, m)
# define SIMDPP_PP_FOR_9(s, p, o, m) SIMDPP_PP_FOR_9_C(SIMDPP_PP_BOOL(p(10, s)), s, p, o, m)
# define SIMDPP_PP_FOR_10(s, p, o, m) SIMDPP_PP_FOR_10_C(SIMDPP_PP_BOOL(p(11, s)), s, p, o, m)
# define SIMDPP_PP_FOR_11(s, p, o, m) SIMDPP_PP_FOR_11_C(SIMDPP_PP_BOOL(p(12, s)), s, p, o, m)
# define SIMDPP_PP_FOR_12(s, p, o, m) SIMDPP_PP_FOR_12_C(SIMDPP_PP_BOOL(p(13, s)), s, p, o, m)
# define SIMDPP_PP_FOR_13(s, p, o, m) SIMDPP_PP_FOR_13_C(SIMDPP_PP_BOOL(p(14, s)), s, p, o, m)
# define SIMDPP_PP_FOR_14(s, p, o, m) SIMDPP_PP_FOR_14_C(SIMDPP_PP_BOOL(p(15, s)), s, p, o, m)
# define SIMDPP_PP_FOR_15(s, p, o, m) SIMDPP_PP_FOR_15_C(SIMDPP_PP_BOOL(p(16, s)), s, p, o, m)
# define SIMDPP_PP_FOR_16(s, p, o, m) SIMDPP_PP_FOR_16_C(SIMDPP_PP_BOOL(p(17, s)), s, p, o, m)
# define SIMDPP_PP_FOR_17(s, p, o, m) SIMDPP_PP_FOR_17_C(SIMDPP_PP_BOOL(p(18, s)), s, p, o, m)
# define SIMDPP_PP_FOR_18(s, p, o, m) SIMDPP_PP_FOR_18_C(SIMDPP_PP_BOOL(p(19, s)), s, p, o, m)
# define SIMDPP_PP_FOR_19(s, p, o, m) SIMDPP_PP_FOR_19_C(SIMDPP_PP_BOOL(p(20, s)), s, p, o, m)
# define SIMDPP_PP_FOR_20(s, p, o, m) SIMDPP_PP_FOR_20_C(SIMDPP_PP_BOOL(p(21, s)), s, p, o, m)
# define SIMDPP_PP_FOR_21(s, p, o, m) SIMDPP_PP_FOR_21_C(SIMDPP_PP_BOOL(p(22, s)), s, p, o, m)
# define SIMDPP_PP_FOR_22(s, p, o, m) SIMDPP_PP_FOR_22_C(SIMDPP_PP_BOOL(p(23, s)), s, p, o, m)
# define SIMDPP_PP_FOR_23(s, p, o, m) SIMDPP_PP_FOR_23_C(SIMDPP_PP_BOOL(p(24, s)), s, p, o, m)
# define SIMDPP_PP_FOR_24(s, p, o, m) SIMDPP_PP_FOR_24_C(SIMDPP_PP_BOOL(p(25, s)), s, p, o, m)
# define SIMDPP_PP_FOR_25(s, p, o, m) SIMDPP_PP_FOR_25_C(SIMDPP_PP_BOOL(p(26, s)), s, p, o, m)
# define SIMDPP_PP_FOR_26(s, p, o, m) SIMDPP_PP_FOR_26_C(SIMDPP_PP_BOOL(p(27, s)), s, p, o, m)
# define SIMDPP_PP_FOR_27(s, p, o, m) SIMDPP_PP_FOR_27_C(SIMDPP_PP_BOOL(p(28, s)), s, p, o, m)
# define SIMDPP_PP_FOR_28(s, p, o, m) SIMDPP_PP_FOR_28_C(SIMDPP_PP_BOOL(p(29, s)), s, p, o, m)
# define SIMDPP_PP_FOR_29(s, p, o, m) SIMDPP_PP_FOR_29_C(SIMDPP_PP_BOOL(p(30, s)), s, p, o, m)
# define SIMDPP_PP_FOR_30(s, p, o, m) SIMDPP_PP_FOR_30_C(SIMDPP_PP_BOOL(p(31, s)), s, p, o, m)
# define SIMDPP_PP_FOR_31(s, p, o, m) SIMDPP_PP_FOR_31_C(SIMDPP_PP_BOOL(p(32, s)), s, p, o, m)
# define SIMDPP_PP_FOR_32(s, p, o, m) SIMDPP_PP_FOR_32_C(SIMDPP_PP_BOOL(p(33, s)), s, p, o, m)
# define SIMDPP_PP_FOR_33(s, p, o, m) SIMDPP_PP_FOR_33_C(SIMDPP_PP_BOOL(p(34, s)), s, p, o, m)
# define SIMDPP_PP_FOR_34(s, p, o, m) SIMDPP_PP_FOR_34_C(SIMDPP_PP_BOOL(p(35, s)), s, p, o, m)
# define SIMDPP_PP_FOR_35(s, p, o, m) SIMDPP_PP_FOR_35_C(SIMDPP_PP_BOOL(p(36, s)), s, p, o, m)
# define SIMDPP_PP_FOR_36(s, p, o, m) SIMDPP_PP_FOR_36_C(SIMDPP_PP_BOOL(p(37, s)), s, p, o, m)
# define SIMDPP_PP_FOR_37(s, p, o, m) SIMDPP_PP_FOR_37_C(SIMDPP_PP_BOOL(p(38, s)), s, p, o, m)
# define SIMDPP_PP_FOR_38(s, p, o, m) SIMDPP_PP_FOR_38_C(SIMDPP_PP_BOOL(p(39, s)), s, p, o, m)
# define SIMDPP_PP_FOR_39(s, p, o, m) SIMDPP_PP_FOR_39_C(SIMDPP_PP_BOOL(p(40, s)), s, p, o, m)
# define SIMDPP_PP_FOR_40(s, p, o, m) SIMDPP_PP_FOR_40_C(SIMDPP_PP_BOOL(p(41, s)), s, p, o, m)
# define SIMDPP_PP_FOR_41(s, p, o, m) SIMDPP_PP_FOR_41_C(SIMDPP_PP_BOOL(p(42, s)), s, p, o, m)
# define SIMDPP_PP_FOR_42(s, p, o, m) SIMDPP_PP_FOR_42_C(SIMDPP_PP_BOOL(p(43, s)), s, p, o, m)
# define SIMDPP_PP_FOR_43(s, p, o, m) SIMDPP_PP_FOR_43_C(SIMDPP_PP_BOOL(p(44, s)), s, p, o, m)
# define SIMDPP_PP_FOR_44(s, p, o, m) SIMDPP_PP_FOR_44_C(SIMDPP_PP_BOOL(p(45, s)), s, p, o, m)
# define SIMDPP_PP_FOR_45(s, p, o, m) SIMDPP_PP_FOR_45_C(SIMDPP_PP_BOOL(p(46, s)), s, p, o, m)
# define SIMDPP_PP_FOR_46(s, p, o, m) SIMDPP_PP_FOR_46_C(SIMDPP_PP_BOOL(p(47, s)), s, p, o, m)
# define SIMDPP_PP_FOR_47(s, p, o, m) SIMDPP_PP_FOR_47_C(SIMDPP_PP_BOOL(p(48, s)), s, p, o, m)
# define SIMDPP_PP_FOR_48(s, p, o, m) SIMDPP_PP_FOR_48_C(SIMDPP_PP_BOOL(p(49, s)), s, p, o, m)
# define SIMDPP_PP_FOR_49(s, p, o, m) SIMDPP_PP_FOR_49_C(SIMDPP_PP_BOOL(p(50, s)), s, p, o, m)
# define SIMDPP_PP_FOR_50(s, p, o, m) SIMDPP_PP_FOR_50_C(SIMDPP_PP_BOOL(p(51, s)), s, p, o, m)
# define SIMDPP_PP_FOR_51(s, p, o, m) SIMDPP_PP_FOR_51_C(SIMDPP_PP_BOOL(p(52, s)), s, p, o, m)
# define SIMDPP_PP_FOR_52(s, p, o, m) SIMDPP_PP_FOR_52_C(SIMDPP_PP_BOOL(p(53, s)), s, p, o, m)
# define SIMDPP_PP_FOR_53(s, p, o, m) SIMDPP_PP_FOR_53_C(SIMDPP_PP_BOOL(p(54, s)), s, p, o, m)
# define SIMDPP_PP_FOR_54(s, p, o, m) SIMDPP_PP_FOR_54_C(SIMDPP_PP_BOOL(p(55, s)), s, p, o, m)
# define SIMDPP_PP_FOR_55(s, p, o, m) SIMDPP_PP_FOR_55_C(SIMDPP_PP_BOOL(p(56, s)), s, p, o, m)
# define SIMDPP_PP_FOR_56(s, p, o, m) SIMDPP_PP_FOR_56_C(SIMDPP_PP_BOOL(p(57, s)), s, p, o, m)
# define SIMDPP_PP_FOR_57(s, p, o, m) SIMDPP_PP_FOR_57_C(SIMDPP_PP_BOOL(p(58, s)), s, p, o, m)
# define SIMDPP_PP_FOR_58(s, p, o, m) SIMDPP_PP_FOR_58_C(SIMDPP_PP_BOOL(p(59, s)), s, p, o, m)
# define SIMDPP_PP_FOR_59(s, p, o, m) SIMDPP_PP_FOR_59_C(SIMDPP_PP_BOOL(p(60, s)), s, p, o, m)
# define SIMDPP_PP_FOR_60(s, p, o, m) SIMDPP_PP_FOR_60_C(SIMDPP_PP_BOOL(p(61, s)), s, p, o, m)
# define SIMDPP_PP_FOR_61(s, p, o, m) SIMDPP_PP_FOR_61_C(SIMDPP_PP_BOOL(p(62, s)), s, p, o, m)
# define SIMDPP_PP_FOR_62(s, p, o, m) SIMDPP_PP_FOR_62_C(SIMDPP_PP_BOOL(p(63, s)), s, p, o, m)
# define SIMDPP_PP_FOR_63(s, p, o, m) SIMDPP_PP_FOR_63_C(SIMDPP_PP_BOOL(p(64, s)), s, p, o, m)
# define SIMDPP_PP_FOR_64(s, p, o, m) SIMDPP_PP_FOR_64_C(SIMDPP_PP_BOOL(p(65, s)), s, p, o, m)
# define SIMDPP_PP_FOR_65(s, p, o, m) SIMDPP_PP_FOR_65_C(SIMDPP_PP_BOOL(p(66, s)), s, p, o, m)
# define SIMDPP_PP_FOR_66(s, p, o, m) SIMDPP_PP_FOR_66_C(SIMDPP_PP_BOOL(p(67, s)), s, p, o, m)
# define SIMDPP_PP_FOR_67(s, p, o, m) SIMDPP_PP_FOR_67_C(SIMDPP_PP_BOOL(p(68, s)), s, p, o, m)
# define SIMDPP_PP_FOR_68(s, p, o, m) SIMDPP_PP_FOR_68_C(SIMDPP_PP_BOOL(p(69, s)), s, p, o, m)
# define SIMDPP_PP_FOR_69(s, p, o, m) SIMDPP_PP_FOR_69_C(SIMDPP_PP_BOOL(p(70, s)), s, p, o, m)
# define SIMDPP_PP_FOR_70(s, p, o, m) SIMDPP_PP_FOR_70_C(SIMDPP_PP_BOOL(p(71, s)), s, p, o, m)
# define SIMDPP_PP_FOR_71(s, p, o, m) SIMDPP_PP_FOR_71_C(SIMDPP_PP_BOOL(p(72, s)), s, p, o, m)
# define SIMDPP_PP_FOR_72(s, p, o, m) SIMDPP_PP_FOR_72_C(SIMDPP_PP_BOOL(p(73, s)), s, p, o, m)
# define SIMDPP_PP_FOR_73(s, p, o, m) SIMDPP_PP_FOR_73_C(SIMDPP_PP_BOOL(p(74, s)), s, p, o, m)
# define SIMDPP_PP_FOR_74(s, p, o, m) SIMDPP_PP_FOR_74_C(SIMDPP_PP_BOOL(p(75, s)), s, p, o, m)
# define SIMDPP_PP_FOR_75(s, p, o, m) SIMDPP_PP_FOR_75_C(SIMDPP_PP_BOOL(p(76, s)), s, p, o, m)
# define SIMDPP_PP_FOR_76(s, p, o, m) SIMDPP_PP_FOR_76_C(SIMDPP_PP_BOOL(p(77, s)), s, p, o, m)
# define SIMDPP_PP_FOR_77(s, p, o, m) SIMDPP_PP_FOR_77_C(SIMDPP_PP_BOOL(p(78, s)), s, p, o, m)
# define SIMDPP_PP_FOR_78(s, p, o, m) SIMDPP_PP_FOR_78_C(SIMDPP_PP_BOOL(p(79, s)), s, p, o, m)
# define SIMDPP_PP_FOR_79(s, p, o, m) SIMDPP_PP_FOR_79_C(SIMDPP_PP_BOOL(p(80, s)), s, p, o, m)
# define SIMDPP_PP_FOR_80(s, p, o, m) SIMDPP_PP_FOR_80_C(SIMDPP_PP_BOOL(p(81, s)), s, p, o, m)
# define SIMDPP_PP_FOR_81(s, p, o, m) SIMDPP_PP_FOR_81_C(SIMDPP_PP_BOOL(p(82, s)), s, p, o, m)
# define SIMDPP_PP_FOR_82(s, p, o, m) SIMDPP_PP_FOR_82_C(SIMDPP_PP_BOOL(p(83, s)), s, p, o, m)
# define SIMDPP_PP_FOR_83(s, p, o, m) SIMDPP_PP_FOR_83_C(SIMDPP_PP_BOOL(p(84, s)), s, p, o, m)
# define SIMDPP_PP_FOR_84(s, p, o, m) SIMDPP_PP_FOR_84_C(SIMDPP_PP_BOOL(p(85, s)), s, p, o, m)
# define SIMDPP_PP_FOR_85(s, p, o, m) SIMDPP_PP_FOR_85_C(SIMDPP_PP_BOOL(p(86, s)), s, p, o, m)
# define SIMDPP_PP_FOR_86(s, p, o, m) SIMDPP_PP_FOR_86_C(SIMDPP_PP_BOOL(p(87, s)), s, p, o, m)
# define SIMDPP_PP_FOR_87(s, p, o, m) SIMDPP_PP_FOR_87_C(SIMDPP_PP_BOOL(p(88, s)), s, p, o, m)
# define SIMDPP_PP_FOR_88(s, p, o, m) SIMDPP_PP_FOR_88_C(SIMDPP_PP_BOOL(p(89, s)), s, p, o, m)
# define SIMDPP_PP_FOR_89(s, p, o, m) SIMDPP_PP_FOR_89_C(SIMDPP_PP_BOOL(p(90, s)), s, p, o, m)
# define SIMDPP_PP_FOR_90(s, p, o, m) SIMDPP_PP_FOR_90_C(SIMDPP_PP_BOOL(p(91, s)), s, p, o, m)
# define SIMDPP_PP_FOR_91(s, p, o, m) SIMDPP_PP_FOR_91_C(SIMDPP_PP_BOOL(p(92, s)), s, p, o, m)
# define SIMDPP_PP_FOR_92(s, p, o, m) SIMDPP_PP_FOR_92_C(SIMDPP_PP_BOOL(p(93, s)), s, p, o, m)
# define SIMDPP_PP_FOR_93(s, p, o, m) SIMDPP_PP_FOR_93_C(SIMDPP_PP_BOOL(p(94, s)), s, p, o, m)
# define SIMDPP_PP_FOR_94(s, p, o, m) SIMDPP_PP_FOR_94_C(SIMDPP_PP_BOOL(p(95, s)), s, p, o, m)
# define SIMDPP_PP_FOR_95(s, p, o, m) SIMDPP_PP_FOR_95_C(SIMDPP_PP_BOOL(p(96, s)), s, p, o, m)
# define SIMDPP_PP_FOR_96(s, p, o, m) SIMDPP_PP_FOR_96_C(SIMDPP_PP_BOOL(p(97, s)), s, p, o, m)
# define SIMDPP_PP_FOR_97(s, p, o, m) SIMDPP_PP_FOR_97_C(SIMDPP_PP_BOOL(p(98, s)), s, p, o, m)
# define SIMDPP_PP_FOR_98(s, p, o, m) SIMDPP_PP_FOR_98_C(SIMDPP_PP_BOOL(p(99, s)), s, p, o, m)
# define SIMDPP_PP_FOR_99(s, p, o, m) SIMDPP_PP_FOR_99_C(SIMDPP_PP_BOOL(p(100, s)), s, p, o, m)
# define SIMDPP_PP_FOR_100(s, p, o, m) SIMDPP_PP_FOR_100_C(SIMDPP_PP_BOOL(p(101, s)), s, p, o, m)
# define SIMDPP_PP_FOR_101(s, p, o, m) SIMDPP_PP_FOR_101_C(SIMDPP_PP_BOOL(p(102, s)), s, p, o, m)
# define SIMDPP_PP_FOR_102(s, p, o, m) SIMDPP_PP_FOR_102_C(SIMDPP_PP_BOOL(p(103, s)), s, p, o, m)
# define SIMDPP_PP_FOR_103(s, p, o, m) SIMDPP_PP_FOR_103_C(SIMDPP_PP_BOOL(p(104, s)), s, p, o, m)
# define SIMDPP_PP_FOR_104(s, p, o, m) SIMDPP_PP_FOR_104_C(SIMDPP_PP_BOOL(p(105, s)), s, p, o, m)
# define SIMDPP_PP_FOR_105(s, p, o, m) SIMDPP_PP_FOR_105_C(SIMDPP_PP_BOOL(p(106, s)), s, p, o, m)
# define SIMDPP_PP_FOR_106(s, p, o, m) SIMDPP_PP_FOR_106_C(SIMDPP_PP_BOOL(p(107, s)), s, p, o, m)
# define SIMDPP_PP_FOR_107(s, p, o, m) SIMDPP_PP_FOR_107_C(SIMDPP_PP_BOOL(p(108, s)), s, p, o, m)
# define SIMDPP_PP_FOR_108(s, p, o, m) SIMDPP_PP_FOR_108_C(SIMDPP_PP_BOOL(p(109, s)), s, p, o, m)
# define SIMDPP_PP_FOR_109(s, p, o, m) SIMDPP_PP_FOR_109_C(SIMDPP_PP_BOOL(p(110, s)), s, p, o, m)
# define SIMDPP_PP_FOR_110(s, p, o, m) SIMDPP_PP_FOR_110_C(SIMDPP_PP_BOOL(p(111, s)), s, p, o, m)
# define SIMDPP_PP_FOR_111(s, p, o, m) SIMDPP_PP_FOR_111_C(SIMDPP_PP_BOOL(p(112, s)), s, p, o, m)
# define SIMDPP_PP_FOR_112(s, p, o, m) SIMDPP_PP_FOR_112_C(SIMDPP_PP_BOOL(p(113, s)), s, p, o, m)
# define SIMDPP_PP_FOR_113(s, p, o, m) SIMDPP_PP_FOR_113_C(SIMDPP_PP_BOOL(p(114, s)), s, p, o, m)
# define SIMDPP_PP_FOR_114(s, p, o, m) SIMDPP_PP_FOR_114_C(SIMDPP_PP_BOOL(p(115, s)), s, p, o, m)
# define SIMDPP_PP_FOR_115(s, p, o, m) SIMDPP_PP_FOR_115_C(SIMDPP_PP_BOOL(p(116, s)), s, p, o, m)
# define SIMDPP_PP_FOR_116(s, p, o, m) SIMDPP_PP_FOR_116_C(SIMDPP_PP_BOOL(p(117, s)), s, p, o, m)
# define SIMDPP_PP_FOR_117(s, p, o, m) SIMDPP_PP_FOR_117_C(SIMDPP_PP_BOOL(p(118, s)), s, p, o, m)
# define SIMDPP_PP_FOR_118(s, p, o, m) SIMDPP_PP_FOR_118_C(SIMDPP_PP_BOOL(p(119, s)), s, p, o, m)
# define SIMDPP_PP_FOR_119(s, p, o, m) SIMDPP_PP_FOR_119_C(SIMDPP_PP_BOOL(p(120, s)), s, p, o, m)
# define SIMDPP_PP_FOR_120(s, p, o, m) SIMDPP_PP_FOR_120_C(SIMDPP_PP_BOOL(p(121, s)), s, p, o, m)
# define SIMDPP_PP_FOR_121(s, p, o, m) SIMDPP_PP_FOR_121_C(SIMDPP_PP_BOOL(p(122, s)), s, p, o, m)
# define SIMDPP_PP_FOR_122(s, p, o, m) SIMDPP_PP_FOR_122_C(SIMDPP_PP_BOOL(p(123, s)), s, p, o, m)
# define SIMDPP_PP_FOR_123(s, p, o, m) SIMDPP_PP_FOR_123_C(SIMDPP_PP_BOOL(p(124, s)), s, p, o, m)
# define SIMDPP_PP_FOR_124(s, p, o, m) SIMDPP_PP_FOR_124_C(SIMDPP_PP_BOOL(p(125, s)), s, p, o, m)
# define SIMDPP_PP_FOR_125(s, p, o, m) SIMDPP_PP_FOR_125_C(SIMDPP_PP_BOOL(p(126, s)), s, p, o, m)
# define SIMDPP_PP_FOR_126(s, p, o, m) SIMDPP_PP_FOR_126_C(SIMDPP_PP_BOOL(p(127, s)), s, p, o, m)
# define SIMDPP_PP_FOR_127(s, p, o, m) SIMDPP_PP_FOR_127_C(SIMDPP_PP_BOOL(p(128, s)), s, p, o, m)
# define SIMDPP_PP_FOR_128(s, p, o, m) SIMDPP_PP_FOR_128_C(SIMDPP_PP_BOOL(p(129, s)), s, p, o, m)
# define SIMDPP_PP_FOR_129(s, p, o, m) SIMDPP_PP_FOR_129_C(SIMDPP_PP_BOOL(p(130, s)), s, p, o, m)
# define SIMDPP_PP_FOR_130(s, p, o, m) SIMDPP_PP_FOR_130_C(SIMDPP_PP_BOOL(p(131, s)), s, p, o, m)
# define SIMDPP_PP_FOR_131(s, p, o, m) SIMDPP_PP_FOR_131_C(SIMDPP_PP_BOOL(p(132, s)), s, p, o, m)
# define SIMDPP_PP_FOR_132(s, p, o, m) SIMDPP_PP_FOR_132_C(SIMDPP_PP_BOOL(p(133, s)), s, p, o, m)
# define SIMDPP_PP_FOR_133(s, p, o, m) SIMDPP_PP_FOR_133_C(SIMDPP_PP_BOOL(p(134, s)), s, p, o, m)
# define SIMDPP_PP_FOR_134(s, p, o, m) SIMDPP_PP_FOR_134_C(SIMDPP_PP_BOOL(p(135, s)), s, p, o, m)
# define SIMDPP_PP_FOR_135(s, p, o, m) SIMDPP_PP_FOR_135_C(SIMDPP_PP_BOOL(p(136, s)), s, p, o, m)
# define SIMDPP_PP_FOR_136(s, p, o, m) SIMDPP_PP_FOR_136_C(SIMDPP_PP_BOOL(p(137, s)), s, p, o, m)
# define SIMDPP_PP_FOR_137(s, p, o, m) SIMDPP_PP_FOR_137_C(SIMDPP_PP_BOOL(p(138, s)), s, p, o, m)
# define SIMDPP_PP_FOR_138(s, p, o, m) SIMDPP_PP_FOR_138_C(SIMDPP_PP_BOOL(p(139, s)), s, p, o, m)
# define SIMDPP_PP_FOR_139(s, p, o, m) SIMDPP_PP_FOR_139_C(SIMDPP_PP_BOOL(p(140, s)), s, p, o, m)
# define SIMDPP_PP_FOR_140(s, p, o, m) SIMDPP_PP_FOR_140_C(SIMDPP_PP_BOOL(p(141, s)), s, p, o, m)
# define SIMDPP_PP_FOR_141(s, p, o, m) SIMDPP_PP_FOR_141_C(SIMDPP_PP_BOOL(p(142, s)), s, p, o, m)
# define SIMDPP_PP_FOR_142(s, p, o, m) SIMDPP_PP_FOR_142_C(SIMDPP_PP_BOOL(p(143, s)), s, p, o, m)
# define SIMDPP_PP_FOR_143(s, p, o, m) SIMDPP_PP_FOR_143_C(SIMDPP_PP_BOOL(p(144, s)), s, p, o, m)
# define SIMDPP_PP_FOR_144(s, p, o, m) SIMDPP_PP_FOR_144_C(SIMDPP_PP_BOOL(p(145, s)), s, p, o, m)
# define SIMDPP_PP_FOR_145(s, p, o, m) SIMDPP_PP_FOR_145_C(SIMDPP_PP_BOOL(p(146, s)), s, p, o, m)
# define SIMDPP_PP_FOR_146(s, p, o, m) SIMDPP_PP_FOR_146_C(SIMDPP_PP_BOOL(p(147, s)), s, p, o, m)
# define SIMDPP_PP_FOR_147(s, p, o, m) SIMDPP_PP_FOR_147_C(SIMDPP_PP_BOOL(p(148, s)), s, p, o, m)
# define SIMDPP_PP_FOR_148(s, p, o, m) SIMDPP_PP_FOR_148_C(SIMDPP_PP_BOOL(p(149, s)), s, p, o, m)
# define SIMDPP_PP_FOR_149(s, p, o, m) SIMDPP_PP_FOR_149_C(SIMDPP_PP_BOOL(p(150, s)), s, p, o, m)
# define SIMDPP_PP_FOR_150(s, p, o, m) SIMDPP_PP_FOR_150_C(SIMDPP_PP_BOOL(p(151, s)), s, p, o, m)
# define SIMDPP_PP_FOR_151(s, p, o, m) SIMDPP_PP_FOR_151_C(SIMDPP_PP_BOOL(p(152, s)), s, p, o, m)
# define SIMDPP_PP_FOR_152(s, p, o, m) SIMDPP_PP_FOR_152_C(SIMDPP_PP_BOOL(p(153, s)), s, p, o, m)
# define SIMDPP_PP_FOR_153(s, p, o, m) SIMDPP_PP_FOR_153_C(SIMDPP_PP_BOOL(p(154, s)), s, p, o, m)
# define SIMDPP_PP_FOR_154(s, p, o, m) SIMDPP_PP_FOR_154_C(SIMDPP_PP_BOOL(p(155, s)), s, p, o, m)
# define SIMDPP_PP_FOR_155(s, p, o, m) SIMDPP_PP_FOR_155_C(SIMDPP_PP_BOOL(p(156, s)), s, p, o, m)
# define SIMDPP_PP_FOR_156(s, p, o, m) SIMDPP_PP_FOR_156_C(SIMDPP_PP_BOOL(p(157, s)), s, p, o, m)
# define SIMDPP_PP_FOR_157(s, p, o, m) SIMDPP_PP_FOR_157_C(SIMDPP_PP_BOOL(p(158, s)), s, p, o, m)
# define SIMDPP_PP_FOR_158(s, p, o, m) SIMDPP_PP_FOR_158_C(SIMDPP_PP_BOOL(p(159, s)), s, p, o, m)
# define SIMDPP_PP_FOR_159(s, p, o, m) SIMDPP_PP_FOR_159_C(SIMDPP_PP_BOOL(p(160, s)), s, p, o, m)
# define SIMDPP_PP_FOR_160(s, p, o, m) SIMDPP_PP_FOR_160_C(SIMDPP_PP_BOOL(p(161, s)), s, p, o, m)
# define SIMDPP_PP_FOR_161(s, p, o, m) SIMDPP_PP_FOR_161_C(SIMDPP_PP_BOOL(p(162, s)), s, p, o, m)
# define SIMDPP_PP_FOR_162(s, p, o, m) SIMDPP_PP_FOR_162_C(SIMDPP_PP_BOOL(p(163, s)), s, p, o, m)
# define SIMDPP_PP_FOR_163(s, p, o, m) SIMDPP_PP_FOR_163_C(SIMDPP_PP_BOOL(p(164, s)), s, p, o, m)
# define SIMDPP_PP_FOR_164(s, p, o, m) SIMDPP_PP_FOR_164_C(SIMDPP_PP_BOOL(p(165, s)), s, p, o, m)
# define SIMDPP_PP_FOR_165(s, p, o, m) SIMDPP_PP_FOR_165_C(SIMDPP_PP_BOOL(p(166, s)), s, p, o, m)
# define SIMDPP_PP_FOR_166(s, p, o, m) SIMDPP_PP_FOR_166_C(SIMDPP_PP_BOOL(p(167, s)), s, p, o, m)
# define SIMDPP_PP_FOR_167(s, p, o, m) SIMDPP_PP_FOR_167_C(SIMDPP_PP_BOOL(p(168, s)), s, p, o, m)
# define SIMDPP_PP_FOR_168(s, p, o, m) SIMDPP_PP_FOR_168_C(SIMDPP_PP_BOOL(p(169, s)), s, p, o, m)
# define SIMDPP_PP_FOR_169(s, p, o, m) SIMDPP_PP_FOR_169_C(SIMDPP_PP_BOOL(p(170, s)), s, p, o, m)
# define SIMDPP_PP_FOR_170(s, p, o, m) SIMDPP_PP_FOR_170_C(SIMDPP_PP_BOOL(p(171, s)), s, p, o, m)
# define SIMDPP_PP_FOR_171(s, p, o, m) SIMDPP_PP_FOR_171_C(SIMDPP_PP_BOOL(p(172, s)), s, p, o, m)
# define SIMDPP_PP_FOR_172(s, p, o, m) SIMDPP_PP_FOR_172_C(SIMDPP_PP_BOOL(p(173, s)), s, p, o, m)
# define SIMDPP_PP_FOR_173(s, p, o, m) SIMDPP_PP_FOR_173_C(SIMDPP_PP_BOOL(p(174, s)), s, p, o, m)
# define SIMDPP_PP_FOR_174(s, p, o, m) SIMDPP_PP_FOR_174_C(SIMDPP_PP_BOOL(p(175, s)), s, p, o, m)
# define SIMDPP_PP_FOR_175(s, p, o, m) SIMDPP_PP_FOR_175_C(SIMDPP_PP_BOOL(p(176, s)), s, p, o, m)
# define SIMDPP_PP_FOR_176(s, p, o, m) SIMDPP_PP_FOR_176_C(SIMDPP_PP_BOOL(p(177, s)), s, p, o, m)
# define SIMDPP_PP_FOR_177(s, p, o, m) SIMDPP_PP_FOR_177_C(SIMDPP_PP_BOOL(p(178, s)), s, p, o, m)
# define SIMDPP_PP_FOR_178(s, p, o, m) SIMDPP_PP_FOR_178_C(SIMDPP_PP_BOOL(p(179, s)), s, p, o, m)
# define SIMDPP_PP_FOR_179(s, p, o, m) SIMDPP_PP_FOR_179_C(SIMDPP_PP_BOOL(p(180, s)), s, p, o, m)
# define SIMDPP_PP_FOR_180(s, p, o, m) SIMDPP_PP_FOR_180_C(SIMDPP_PP_BOOL(p(181, s)), s, p, o, m)
# define SIMDPP_PP_FOR_181(s, p, o, m) SIMDPP_PP_FOR_181_C(SIMDPP_PP_BOOL(p(182, s)), s, p, o, m)
# define SIMDPP_PP_FOR_182(s, p, o, m) SIMDPP_PP_FOR_182_C(SIMDPP_PP_BOOL(p(183, s)), s, p, o, m)
# define SIMDPP_PP_FOR_183(s, p, o, m) SIMDPP_PP_FOR_183_C(SIMDPP_PP_BOOL(p(184, s)), s, p, o, m)
# define SIMDPP_PP_FOR_184(s, p, o, m) SIMDPP_PP_FOR_184_C(SIMDPP_PP_BOOL(p(185, s)), s, p, o, m)
# define SIMDPP_PP_FOR_185(s, p, o, m) SIMDPP_PP_FOR_185_C(SIMDPP_PP_BOOL(p(186, s)), s, p, o, m)
# define SIMDPP_PP_FOR_186(s, p, o, m) SIMDPP_PP_FOR_186_C(SIMDPP_PP_BOOL(p(187, s)), s, p, o, m)
# define SIMDPP_PP_FOR_187(s, p, o, m) SIMDPP_PP_FOR_187_C(SIMDPP_PP_BOOL(p(188, s)), s, p, o, m)
# define SIMDPP_PP_FOR_188(s, p, o, m) SIMDPP_PP_FOR_188_C(SIMDPP_PP_BOOL(p(189, s)), s, p, o, m)
# define SIMDPP_PP_FOR_189(s, p, o, m) SIMDPP_PP_FOR_189_C(SIMDPP_PP_BOOL(p(190, s)), s, p, o, m)
# define SIMDPP_PP_FOR_190(s, p, o, m) SIMDPP_PP_FOR_190_C(SIMDPP_PP_BOOL(p(191, s)), s, p, o, m)
# define SIMDPP_PP_FOR_191(s, p, o, m) SIMDPP_PP_FOR_191_C(SIMDPP_PP_BOOL(p(192, s)), s, p, o, m)
# define SIMDPP_PP_FOR_192(s, p, o, m) SIMDPP_PP_FOR_192_C(SIMDPP_PP_BOOL(p(193, s)), s, p, o, m)
# define SIMDPP_PP_FOR_193(s, p, o, m) SIMDPP_PP_FOR_193_C(SIMDPP_PP_BOOL(p(194, s)), s, p, o, m)
# define SIMDPP_PP_FOR_194(s, p, o, m) SIMDPP_PP_FOR_194_C(SIMDPP_PP_BOOL(p(195, s)), s, p, o, m)
# define SIMDPP_PP_FOR_195(s, p, o, m) SIMDPP_PP_FOR_195_C(SIMDPP_PP_BOOL(p(196, s)), s, p, o, m)
# define SIMDPP_PP_FOR_196(s, p, o, m) SIMDPP_PP_FOR_196_C(SIMDPP_PP_BOOL(p(197, s)), s, p, o, m)
# define SIMDPP_PP_FOR_197(s, p, o, m) SIMDPP_PP_FOR_197_C(SIMDPP_PP_BOOL(p(198, s)), s, p, o, m)
# define SIMDPP_PP_FOR_198(s, p, o, m) SIMDPP_PP_FOR_198_C(SIMDPP_PP_BOOL(p(199, s)), s, p, o, m)
# define SIMDPP_PP_FOR_199(s, p, o, m) SIMDPP_PP_FOR_199_C(SIMDPP_PP_BOOL(p(200, s)), s, p, o, m)
# define SIMDPP_PP_FOR_200(s, p, o, m) SIMDPP_PP_FOR_200_C(SIMDPP_PP_BOOL(p(201, s)), s, p, o, m)
# define SIMDPP_PP_FOR_201(s, p, o, m) SIMDPP_PP_FOR_201_C(SIMDPP_PP_BOOL(p(202, s)), s, p, o, m)
# define SIMDPP_PP_FOR_202(s, p, o, m) SIMDPP_PP_FOR_202_C(SIMDPP_PP_BOOL(p(203, s)), s, p, o, m)
# define SIMDPP_PP_FOR_203(s, p, o, m) SIMDPP_PP_FOR_203_C(SIMDPP_PP_BOOL(p(204, s)), s, p, o, m)
# define SIMDPP_PP_FOR_204(s, p, o, m) SIMDPP_PP_FOR_204_C(SIMDPP_PP_BOOL(p(205, s)), s, p, o, m)
# define SIMDPP_PP_FOR_205(s, p, o, m) SIMDPP_PP_FOR_205_C(SIMDPP_PP_BOOL(p(206, s)), s, p, o, m)
# define SIMDPP_PP_FOR_206(s, p, o, m) SIMDPP_PP_FOR_206_C(SIMDPP_PP_BOOL(p(207, s)), s, p, o, m)
# define SIMDPP_PP_FOR_207(s, p, o, m) SIMDPP_PP_FOR_207_C(SIMDPP_PP_BOOL(p(208, s)), s, p, o, m)
# define SIMDPP_PP_FOR_208(s, p, o, m) SIMDPP_PP_FOR_208_C(SIMDPP_PP_BOOL(p(209, s)), s, p, o, m)
# define SIMDPP_PP_FOR_209(s, p, o, m) SIMDPP_PP_FOR_209_C(SIMDPP_PP_BOOL(p(210, s)), s, p, o, m)
# define SIMDPP_PP_FOR_210(s, p, o, m) SIMDPP_PP_FOR_210_C(SIMDPP_PP_BOOL(p(211, s)), s, p, o, m)
# define SIMDPP_PP_FOR_211(s, p, o, m) SIMDPP_PP_FOR_211_C(SIMDPP_PP_BOOL(p(212, s)), s, p, o, m)
# define SIMDPP_PP_FOR_212(s, p, o, m) SIMDPP_PP_FOR_212_C(SIMDPP_PP_BOOL(p(213, s)), s, p, o, m)
# define SIMDPP_PP_FOR_213(s, p, o, m) SIMDPP_PP_FOR_213_C(SIMDPP_PP_BOOL(p(214, s)), s, p, o, m)
# define SIMDPP_PP_FOR_214(s, p, o, m) SIMDPP_PP_FOR_214_C(SIMDPP_PP_BOOL(p(215, s)), s, p, o, m)
# define SIMDPP_PP_FOR_215(s, p, o, m) SIMDPP_PP_FOR_215_C(SIMDPP_PP_BOOL(p(216, s)), s, p, o, m)
# define SIMDPP_PP_FOR_216(s, p, o, m) SIMDPP_PP_FOR_216_C(SIMDPP_PP_BOOL(p(217, s)), s, p, o, m)
# define SIMDPP_PP_FOR_217(s, p, o, m) SIMDPP_PP_FOR_217_C(SIMDPP_PP_BOOL(p(218, s)), s, p, o, m)
# define SIMDPP_PP_FOR_218(s, p, o, m) SIMDPP_PP_FOR_218_C(SIMDPP_PP_BOOL(p(219, s)), s, p, o, m)
# define SIMDPP_PP_FOR_219(s, p, o, m) SIMDPP_PP_FOR_219_C(SIMDPP_PP_BOOL(p(220, s)), s, p, o, m)
# define SIMDPP_PP_FOR_220(s, p, o, m) SIMDPP_PP_FOR_220_C(SIMDPP_PP_BOOL(p(221, s)), s, p, o, m)
# define SIMDPP_PP_FOR_221(s, p, o, m) SIMDPP_PP_FOR_221_C(SIMDPP_PP_BOOL(p(222, s)), s, p, o, m)
# define SIMDPP_PP_FOR_222(s, p, o, m) SIMDPP_PP_FOR_222_C(SIMDPP_PP_BOOL(p(223, s)), s, p, o, m)
# define SIMDPP_PP_FOR_223(s, p, o, m) SIMDPP_PP_FOR_223_C(SIMDPP_PP_BOOL(p(224, s)), s, p, o, m)
# define SIMDPP_PP_FOR_224(s, p, o, m) SIMDPP_PP_FOR_224_C(SIMDPP_PP_BOOL(p(225, s)), s, p, o, m)
# define SIMDPP_PP_FOR_225(s, p, o, m) SIMDPP_PP_FOR_225_C(SIMDPP_PP_BOOL(p(226, s)), s, p, o, m)
# define SIMDPP_PP_FOR_226(s, p, o, m) SIMDPP_PP_FOR_226_C(SIMDPP_PP_BOOL(p(227, s)), s, p, o, m)
# define SIMDPP_PP_FOR_227(s, p, o, m) SIMDPP_PP_FOR_227_C(SIMDPP_PP_BOOL(p(228, s)), s, p, o, m)
# define SIMDPP_PP_FOR_228(s, p, o, m) SIMDPP_PP_FOR_228_C(SIMDPP_PP_BOOL(p(229, s)), s, p, o, m)
# define SIMDPP_PP_FOR_229(s, p, o, m) SIMDPP_PP_FOR_229_C(SIMDPP_PP_BOOL(p(230, s)), s, p, o, m)
# define SIMDPP_PP_FOR_230(s, p, o, m) SIMDPP_PP_FOR_230_C(SIMDPP_PP_BOOL(p(231, s)), s, p, o, m)
# define SIMDPP_PP_FOR_231(s, p, o, m) SIMDPP_PP_FOR_231_C(SIMDPP_PP_BOOL(p(232, s)), s, p, o, m)
# define SIMDPP_PP_FOR_232(s, p, o, m) SIMDPP_PP_FOR_232_C(SIMDPP_PP_BOOL(p(233, s)), s, p, o, m)
# define SIMDPP_PP_FOR_233(s, p, o, m) SIMDPP_PP_FOR_233_C(SIMDPP_PP_BOOL(p(234, s)), s, p, o, m)
# define SIMDPP_PP_FOR_234(s, p, o, m) SIMDPP_PP_FOR_234_C(SIMDPP_PP_BOOL(p(235, s)), s, p, o, m)
# define SIMDPP_PP_FOR_235(s, p, o, m) SIMDPP_PP_FOR_235_C(SIMDPP_PP_BOOL(p(236, s)), s, p, o, m)
# define SIMDPP_PP_FOR_236(s, p, o, m) SIMDPP_PP_FOR_236_C(SIMDPP_PP_BOOL(p(237, s)), s, p, o, m)
# define SIMDPP_PP_FOR_237(s, p, o, m) SIMDPP_PP_FOR_237_C(SIMDPP_PP_BOOL(p(238, s)), s, p, o, m)
# define SIMDPP_PP_FOR_238(s, p, o, m) SIMDPP_PP_FOR_238_C(SIMDPP_PP_BOOL(p(239, s)), s, p, o, m)
# define SIMDPP_PP_FOR_239(s, p, o, m) SIMDPP_PP_FOR_239_C(SIMDPP_PP_BOOL(p(240, s)), s, p, o, m)
# define SIMDPP_PP_FOR_240(s, p, o, m) SIMDPP_PP_FOR_240_C(SIMDPP_PP_BOOL(p(241, s)), s, p, o, m)
# define SIMDPP_PP_FOR_241(s, p, o, m) SIMDPP_PP_FOR_241_C(SIMDPP_PP_BOOL(p(242, s)), s, p, o, m)
# define SIMDPP_PP_FOR_242(s, p, o, m) SIMDPP_PP_FOR_242_C(SIMDPP_PP_BOOL(p(243, s)), s, p, o, m)
# define SIMDPP_PP_FOR_243(s, p, o, m) SIMDPP_PP_FOR_243_C(SIMDPP_PP_BOOL(p(244, s)), s, p, o, m)
# define SIMDPP_PP_FOR_244(s, p, o, m) SIMDPP_PP_FOR_244_C(SIMDPP_PP_BOOL(p(245, s)), s, p, o, m)
# define SIMDPP_PP_FOR_245(s, p, o, m) SIMDPP_PP_FOR_245_C(SIMDPP_PP_BOOL(p(246, s)), s, p, o, m)
# define SIMDPP_PP_FOR_246(s, p, o, m) SIMDPP_PP_FOR_246_C(SIMDPP_PP_BOOL(p(247, s)), s, p, o, m)
# define SIMDPP_PP_FOR_247(s, p, o, m) SIMDPP_PP_FOR_247_C(SIMDPP_PP_BOOL(p(248, s)), s, p, o, m)
# define SIMDPP_PP_FOR_248(s, p, o, m) SIMDPP_PP_FOR_248_C(SIMDPP_PP_BOOL(p(249, s)), s, p, o, m)
# define SIMDPP_PP_FOR_249(s, p, o, m) SIMDPP_PP_FOR_249_C(SIMDPP_PP_BOOL(p(250, s)), s, p, o, m)
# define SIMDPP_PP_FOR_250(s, p, o, m) SIMDPP_PP_FOR_250_C(SIMDPP_PP_BOOL(p(251, s)), s, p, o, m)
# define SIMDPP_PP_FOR_251(s, p, o, m) SIMDPP_PP_FOR_251_C(SIMDPP_PP_BOOL(p(252, s)), s, p, o, m)
# define SIMDPP_PP_FOR_252(s, p, o, m) SIMDPP_PP_FOR_252_C(SIMDPP_PP_BOOL(p(253, s)), s, p, o, m)
# define SIMDPP_PP_FOR_253(s, p, o, m) SIMDPP_PP_FOR_253_C(SIMDPP_PP_BOOL(p(254, s)), s, p, o, m)
# define SIMDPP_PP_FOR_254(s, p, o, m) SIMDPP_PP_FOR_254_C(SIMDPP_PP_BOOL(p(255, s)), s, p, o, m)
# define SIMDPP_PP_FOR_255(s, p, o, m) SIMDPP_PP_FOR_255_C(SIMDPP_PP_BOOL(p(256, s)), s, p, o, m)
# define SIMDPP_PP_FOR_256(s, p, o, m) SIMDPP_PP_FOR_256_C(SIMDPP_PP_BOOL(p(257, s)), s, p, o, m)
#
# define SIMDPP_PP_FOR_1_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(2, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_2, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(2, s), p, o, m)
# define SIMDPP_PP_FOR_2_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(3, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_3, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(3, s), p, o, m)
# define SIMDPP_PP_FOR_3_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(4, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_4, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(4, s), p, o, m)
# define SIMDPP_PP_FOR_4_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(5, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_5, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(5, s), p, o, m)
# define SIMDPP_PP_FOR_5_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(6, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_6, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(6, s), p, o, m)
# define SIMDPP_PP_FOR_6_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(7, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_7, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(7, s), p, o, m)
# define SIMDPP_PP_FOR_7_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(8, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_8, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(8, s), p, o, m)
# define SIMDPP_PP_FOR_8_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(9, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_9, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(9, s), p, o, m)
# define SIMDPP_PP_FOR_9_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(10, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_10, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(10, s), p, o, m)
# define SIMDPP_PP_FOR_10_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(11, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_11, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(11, s), p, o, m)
# define SIMDPP_PP_FOR_11_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(12, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_12, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(12, s), p, o, m)
# define SIMDPP_PP_FOR_12_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(13, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_13, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(13, s), p, o, m)
# define SIMDPP_PP_FOR_13_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(14, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_14, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(14, s), p, o, m)
# define SIMDPP_PP_FOR_14_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(15, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_15, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(15, s), p, o, m)
# define SIMDPP_PP_FOR_15_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(16, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_16, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(16, s), p, o, m)
# define SIMDPP_PP_FOR_16_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(17, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_17, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(17, s), p, o, m)
# define SIMDPP_PP_FOR_17_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(18, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_18, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(18, s), p, o, m)
# define SIMDPP_PP_FOR_18_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(19, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_19, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(19, s), p, o, m)
# define SIMDPP_PP_FOR_19_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(20, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_20, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(20, s), p, o, m)
# define SIMDPP_PP_FOR_20_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(21, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_21, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(21, s), p, o, m)
# define SIMDPP_PP_FOR_21_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(22, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_22, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(22, s), p, o, m)
# define SIMDPP_PP_FOR_22_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(23, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_23, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(23, s), p, o, m)
# define SIMDPP_PP_FOR_23_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(24, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_24, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(24, s), p, o, m)
# define SIMDPP_PP_FOR_24_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(25, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_25, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(25, s), p, o, m)
# define SIMDPP_PP_FOR_25_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(26, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_26, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(26, s), p, o, m)
# define SIMDPP_PP_FOR_26_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(27, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_27, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(27, s), p, o, m)
# define SIMDPP_PP_FOR_27_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(28, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_28, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(28, s), p, o, m)
# define SIMDPP_PP_FOR_28_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(29, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_29, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(29, s), p, o, m)
# define SIMDPP_PP_FOR_29_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(30, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_30, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(30, s), p, o, m)
# define SIMDPP_PP_FOR_30_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(31, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_31, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(31, s), p, o, m)
# define SIMDPP_PP_FOR_31_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(32, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_32, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(32, s), p, o, m)
# define SIMDPP_PP_FOR_32_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(33, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_33, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(33, s), p, o, m)
# define SIMDPP_PP_FOR_33_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(34, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_34, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(34, s), p, o, m)
# define SIMDPP_PP_FOR_34_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(35, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_35, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(35, s), p, o, m)
# define SIMDPP_PP_FOR_35_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(36, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_36, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(36, s), p, o, m)
# define SIMDPP_PP_FOR_36_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(37, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_37, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(37, s), p, o, m)
# define SIMDPP_PP_FOR_37_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(38, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_38, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(38, s), p, o, m)
# define SIMDPP_PP_FOR_38_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(39, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_39, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(39, s), p, o, m)
# define SIMDPP_PP_FOR_39_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(40, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_40, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(40, s), p, o, m)
# define SIMDPP_PP_FOR_40_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(41, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_41, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(41, s), p, o, m)
# define SIMDPP_PP_FOR_41_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(42, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_42, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(42, s), p, o, m)
# define SIMDPP_PP_FOR_42_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(43, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_43, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(43, s), p, o, m)
# define SIMDPP_PP_FOR_43_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(44, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_44, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(44, s), p, o, m)
# define SIMDPP_PP_FOR_44_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(45, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_45, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(45, s), p, o, m)
# define SIMDPP_PP_FOR_45_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(46, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_46, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(46, s), p, o, m)
# define SIMDPP_PP_FOR_46_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(47, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_47, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(47, s), p, o, m)
# define SIMDPP_PP_FOR_47_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(48, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_48, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(48, s), p, o, m)
# define SIMDPP_PP_FOR_48_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(49, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_49, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(49, s), p, o, m)
# define SIMDPP_PP_FOR_49_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(50, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_50, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(50, s), p, o, m)
# define SIMDPP_PP_FOR_50_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(51, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_51, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(51, s), p, o, m)
# define SIMDPP_PP_FOR_51_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(52, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_52, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(52, s), p, o, m)
# define SIMDPP_PP_FOR_52_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(53, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_53, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(53, s), p, o, m)
# define SIMDPP_PP_FOR_53_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(54, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_54, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(54, s), p, o, m)
# define SIMDPP_PP_FOR_54_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(55, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_55, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(55, s), p, o, m)
# define SIMDPP_PP_FOR_55_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(56, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_56, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(56, s), p, o, m)
# define SIMDPP_PP_FOR_56_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(57, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_57, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(57, s), p, o, m)
# define SIMDPP_PP_FOR_57_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(58, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_58, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(58, s), p, o, m)
# define SIMDPP_PP_FOR_58_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(59, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_59, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(59, s), p, o, m)
# define SIMDPP_PP_FOR_59_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(60, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_60, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(60, s), p, o, m)
# define SIMDPP_PP_FOR_60_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(61, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_61, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(61, s), p, o, m)
# define SIMDPP_PP_FOR_61_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(62, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_62, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(62, s), p, o, m)
# define SIMDPP_PP_FOR_62_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(63, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_63, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(63, s), p, o, m)
# define SIMDPP_PP_FOR_63_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(64, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_64, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(64, s), p, o, m)
# define SIMDPP_PP_FOR_64_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(65, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_65, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(65, s), p, o, m)
# define SIMDPP_PP_FOR_65_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(66, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_66, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(66, s), p, o, m)
# define SIMDPP_PP_FOR_66_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(67, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_67, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(67, s), p, o, m)
# define SIMDPP_PP_FOR_67_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(68, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_68, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(68, s), p, o, m)
# define SIMDPP_PP_FOR_68_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(69, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_69, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(69, s), p, o, m)
# define SIMDPP_PP_FOR_69_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(70, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_70, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(70, s), p, o, m)
# define SIMDPP_PP_FOR_70_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(71, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_71, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(71, s), p, o, m)
# define SIMDPP_PP_FOR_71_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(72, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_72, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(72, s), p, o, m)
# define SIMDPP_PP_FOR_72_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(73, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_73, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(73, s), p, o, m)
# define SIMDPP_PP_FOR_73_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(74, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_74, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(74, s), p, o, m)
# define SIMDPP_PP_FOR_74_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(75, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_75, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(75, s), p, o, m)
# define SIMDPP_PP_FOR_75_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(76, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_76, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(76, s), p, o, m)
# define SIMDPP_PP_FOR_76_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(77, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_77, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(77, s), p, o, m)
# define SIMDPP_PP_FOR_77_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(78, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_78, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(78, s), p, o, m)
# define SIMDPP_PP_FOR_78_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(79, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_79, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(79, s), p, o, m)
# define SIMDPP_PP_FOR_79_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(80, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_80, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(80, s), p, o, m)
# define SIMDPP_PP_FOR_80_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(81, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_81, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(81, s), p, o, m)
# define SIMDPP_PP_FOR_81_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(82, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_82, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(82, s), p, o, m)
# define SIMDPP_PP_FOR_82_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(83, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_83, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(83, s), p, o, m)
# define SIMDPP_PP_FOR_83_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(84, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_84, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(84, s), p, o, m)
# define SIMDPP_PP_FOR_84_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(85, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_85, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(85, s), p, o, m)
# define SIMDPP_PP_FOR_85_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(86, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_86, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(86, s), p, o, m)
# define SIMDPP_PP_FOR_86_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(87, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_87, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(87, s), p, o, m)
# define SIMDPP_PP_FOR_87_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(88, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_88, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(88, s), p, o, m)
# define SIMDPP_PP_FOR_88_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(89, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_89, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(89, s), p, o, m)
# define SIMDPP_PP_FOR_89_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(90, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_90, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(90, s), p, o, m)
# define SIMDPP_PP_FOR_90_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(91, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_91, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(91, s), p, o, m)
# define SIMDPP_PP_FOR_91_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(92, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_92, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(92, s), p, o, m)
# define SIMDPP_PP_FOR_92_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(93, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_93, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(93, s), p, o, m)
# define SIMDPP_PP_FOR_93_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(94, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_94, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(94, s), p, o, m)
# define SIMDPP_PP_FOR_94_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(95, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_95, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(95, s), p, o, m)
# define SIMDPP_PP_FOR_95_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(96, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_96, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(96, s), p, o, m)
# define SIMDPP_PP_FOR_96_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(97, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_97, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(97, s), p, o, m)
# define SIMDPP_PP_FOR_97_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(98, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_98, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(98, s), p, o, m)
# define SIMDPP_PP_FOR_98_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(99, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_99, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(99, s), p, o, m)
# define SIMDPP_PP_FOR_99_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(100, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_100, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(100, s), p, o, m)
# define SIMDPP_PP_FOR_100_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(101, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_101, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(101, s), p, o, m)
# define SIMDPP_PP_FOR_101_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(102, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_102, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(102, s), p, o, m)
# define SIMDPP_PP_FOR_102_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(103, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_103, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(103, s), p, o, m)
# define SIMDPP_PP_FOR_103_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(104, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_104, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(104, s), p, o, m)
# define SIMDPP_PP_FOR_104_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(105, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_105, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(105, s), p, o, m)
# define SIMDPP_PP_FOR_105_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(106, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_106, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(106, s), p, o, m)
# define SIMDPP_PP_FOR_106_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(107, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_107, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(107, s), p, o, m)
# define SIMDPP_PP_FOR_107_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(108, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_108, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(108, s), p, o, m)
# define SIMDPP_PP_FOR_108_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(109, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_109, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(109, s), p, o, m)
# define SIMDPP_PP_FOR_109_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(110, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_110, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(110, s), p, o, m)
# define SIMDPP_PP_FOR_110_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(111, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_111, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(111, s), p, o, m)
# define SIMDPP_PP_FOR_111_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(112, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_112, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(112, s), p, o, m)
# define SIMDPP_PP_FOR_112_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(113, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_113, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(113, s), p, o, m)
# define SIMDPP_PP_FOR_113_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(114, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_114, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(114, s), p, o, m)
# define SIMDPP_PP_FOR_114_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(115, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_115, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(115, s), p, o, m)
# define SIMDPP_PP_FOR_115_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(116, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_116, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(116, s), p, o, m)
# define SIMDPP_PP_FOR_116_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(117, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_117, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(117, s), p, o, m)
# define SIMDPP_PP_FOR_117_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(118, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_118, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(118, s), p, o, m)
# define SIMDPP_PP_FOR_118_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(119, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_119, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(119, s), p, o, m)
# define SIMDPP_PP_FOR_119_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(120, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_120, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(120, s), p, o, m)
# define SIMDPP_PP_FOR_120_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(121, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_121, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(121, s), p, o, m)
# define SIMDPP_PP_FOR_121_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(122, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_122, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(122, s), p, o, m)
# define SIMDPP_PP_FOR_122_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(123, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_123, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(123, s), p, o, m)
# define SIMDPP_PP_FOR_123_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(124, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_124, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(124, s), p, o, m)
# define SIMDPP_PP_FOR_124_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(125, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_125, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(125, s), p, o, m)
# define SIMDPP_PP_FOR_125_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(126, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_126, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(126, s), p, o, m)
# define SIMDPP_PP_FOR_126_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(127, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_127, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(127, s), p, o, m)
# define SIMDPP_PP_FOR_127_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(128, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_128, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(128, s), p, o, m)
# define SIMDPP_PP_FOR_128_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(129, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_129, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(129, s), p, o, m)
# define SIMDPP_PP_FOR_129_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(130, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_130, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(130, s), p, o, m)
# define SIMDPP_PP_FOR_130_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(131, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_131, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(131, s), p, o, m)
# define SIMDPP_PP_FOR_131_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(132, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_132, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(132, s), p, o, m)
# define SIMDPP_PP_FOR_132_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(133, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_133, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(133, s), p, o, m)
# define SIMDPP_PP_FOR_133_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(134, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_134, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(134, s), p, o, m)
# define SIMDPP_PP_FOR_134_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(135, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_135, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(135, s), p, o, m)
# define SIMDPP_PP_FOR_135_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(136, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_136, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(136, s), p, o, m)
# define SIMDPP_PP_FOR_136_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(137, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_137, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(137, s), p, o, m)
# define SIMDPP_PP_FOR_137_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(138, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_138, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(138, s), p, o, m)
# define SIMDPP_PP_FOR_138_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(139, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_139, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(139, s), p, o, m)
# define SIMDPP_PP_FOR_139_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(140, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_140, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(140, s), p, o, m)
# define SIMDPP_PP_FOR_140_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(141, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_141, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(141, s), p, o, m)
# define SIMDPP_PP_FOR_141_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(142, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_142, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(142, s), p, o, m)
# define SIMDPP_PP_FOR_142_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(143, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_143, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(143, s), p, o, m)
# define SIMDPP_PP_FOR_143_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(144, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_144, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(144, s), p, o, m)
# define SIMDPP_PP_FOR_144_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(145, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_145, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(145, s), p, o, m)
# define SIMDPP_PP_FOR_145_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(146, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_146, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(146, s), p, o, m)
# define SIMDPP_PP_FOR_146_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(147, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_147, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(147, s), p, o, m)
# define SIMDPP_PP_FOR_147_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(148, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_148, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(148, s), p, o, m)
# define SIMDPP_PP_FOR_148_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(149, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_149, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(149, s), p, o, m)
# define SIMDPP_PP_FOR_149_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(150, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_150, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(150, s), p, o, m)
# define SIMDPP_PP_FOR_150_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(151, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_151, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(151, s), p, o, m)
# define SIMDPP_PP_FOR_151_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(152, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_152, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(152, s), p, o, m)
# define SIMDPP_PP_FOR_152_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(153, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_153, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(153, s), p, o, m)
# define SIMDPP_PP_FOR_153_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(154, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_154, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(154, s), p, o, m)
# define SIMDPP_PP_FOR_154_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(155, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_155, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(155, s), p, o, m)
# define SIMDPP_PP_FOR_155_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(156, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_156, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(156, s), p, o, m)
# define SIMDPP_PP_FOR_156_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(157, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_157, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(157, s), p, o, m)
# define SIMDPP_PP_FOR_157_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(158, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_158, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(158, s), p, o, m)
# define SIMDPP_PP_FOR_158_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(159, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_159, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(159, s), p, o, m)
# define SIMDPP_PP_FOR_159_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(160, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_160, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(160, s), p, o, m)
# define SIMDPP_PP_FOR_160_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(161, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_161, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(161, s), p, o, m)
# define SIMDPP_PP_FOR_161_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(162, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_162, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(162, s), p, o, m)
# define SIMDPP_PP_FOR_162_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(163, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_163, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(163, s), p, o, m)
# define SIMDPP_PP_FOR_163_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(164, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_164, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(164, s), p, o, m)
# define SIMDPP_PP_FOR_164_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(165, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_165, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(165, s), p, o, m)
# define SIMDPP_PP_FOR_165_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(166, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_166, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(166, s), p, o, m)
# define SIMDPP_PP_FOR_166_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(167, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_167, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(167, s), p, o, m)
# define SIMDPP_PP_FOR_167_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(168, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_168, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(168, s), p, o, m)
# define SIMDPP_PP_FOR_168_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(169, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_169, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(169, s), p, o, m)
# define SIMDPP_PP_FOR_169_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(170, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_170, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(170, s), p, o, m)
# define SIMDPP_PP_FOR_170_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(171, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_171, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(171, s), p, o, m)
# define SIMDPP_PP_FOR_171_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(172, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_172, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(172, s), p, o, m)
# define SIMDPP_PP_FOR_172_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(173, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_173, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(173, s), p, o, m)
# define SIMDPP_PP_FOR_173_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(174, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_174, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(174, s), p, o, m)
# define SIMDPP_PP_FOR_174_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(175, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_175, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(175, s), p, o, m)
# define SIMDPP_PP_FOR_175_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(176, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_176, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(176, s), p, o, m)
# define SIMDPP_PP_FOR_176_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(177, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_177, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(177, s), p, o, m)
# define SIMDPP_PP_FOR_177_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(178, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_178, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(178, s), p, o, m)
# define SIMDPP_PP_FOR_178_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(179, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_179, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(179, s), p, o, m)
# define SIMDPP_PP_FOR_179_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(180, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_180, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(180, s), p, o, m)
# define SIMDPP_PP_FOR_180_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(181, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_181, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(181, s), p, o, m)
# define SIMDPP_PP_FOR_181_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(182, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_182, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(182, s), p, o, m)
# define SIMDPP_PP_FOR_182_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(183, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_183, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(183, s), p, o, m)
# define SIMDPP_PP_FOR_183_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(184, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_184, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(184, s), p, o, m)
# define SIMDPP_PP_FOR_184_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(185, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_185, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(185, s), p, o, m)
# define SIMDPP_PP_FOR_185_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(186, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_186, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(186, s), p, o, m)
# define SIMDPP_PP_FOR_186_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(187, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_187, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(187, s), p, o, m)
# define SIMDPP_PP_FOR_187_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(188, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_188, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(188, s), p, o, m)
# define SIMDPP_PP_FOR_188_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(189, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_189, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(189, s), p, o, m)
# define SIMDPP_PP_FOR_189_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(190, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_190, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(190, s), p, o, m)
# define SIMDPP_PP_FOR_190_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(191, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_191, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(191, s), p, o, m)
# define SIMDPP_PP_FOR_191_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(192, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_192, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(192, s), p, o, m)
# define SIMDPP_PP_FOR_192_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(193, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_193, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(193, s), p, o, m)
# define SIMDPP_PP_FOR_193_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(194, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_194, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(194, s), p, o, m)
# define SIMDPP_PP_FOR_194_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(195, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_195, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(195, s), p, o, m)
# define SIMDPP_PP_FOR_195_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(196, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_196, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(196, s), p, o, m)
# define SIMDPP_PP_FOR_196_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(197, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_197, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(197, s), p, o, m)
# define SIMDPP_PP_FOR_197_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(198, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_198, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(198, s), p, o, m)
# define SIMDPP_PP_FOR_198_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(199, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_199, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(199, s), p, o, m)
# define SIMDPP_PP_FOR_199_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(200, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_200, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(200, s), p, o, m)
# define SIMDPP_PP_FOR_200_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(201, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_201, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(201, s), p, o, m)
# define SIMDPP_PP_FOR_201_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(202, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_202, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(202, s), p, o, m)
# define SIMDPP_PP_FOR_202_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(203, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_203, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(203, s), p, o, m)
# define SIMDPP_PP_FOR_203_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(204, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_204, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(204, s), p, o, m)
# define SIMDPP_PP_FOR_204_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(205, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_205, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(205, s), p, o, m)
# define SIMDPP_PP_FOR_205_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(206, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_206, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(206, s), p, o, m)
# define SIMDPP_PP_FOR_206_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(207, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_207, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(207, s), p, o, m)
# define SIMDPP_PP_FOR_207_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(208, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_208, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(208, s), p, o, m)
# define SIMDPP_PP_FOR_208_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(209, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_209, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(209, s), p, o, m)
# define SIMDPP_PP_FOR_209_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(210, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_210, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(210, s), p, o, m)
# define SIMDPP_PP_FOR_210_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(211, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_211, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(211, s), p, o, m)
# define SIMDPP_PP_FOR_211_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(212, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_212, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(212, s), p, o, m)
# define SIMDPP_PP_FOR_212_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(213, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_213, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(213, s), p, o, m)
# define SIMDPP_PP_FOR_213_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(214, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_214, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(214, s), p, o, m)
# define SIMDPP_PP_FOR_214_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(215, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_215, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(215, s), p, o, m)
# define SIMDPP_PP_FOR_215_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(216, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_216, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(216, s), p, o, m)
# define SIMDPP_PP_FOR_216_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(217, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_217, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(217, s), p, o, m)
# define SIMDPP_PP_FOR_217_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(218, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_218, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(218, s), p, o, m)
# define SIMDPP_PP_FOR_218_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(219, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_219, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(219, s), p, o, m)
# define SIMDPP_PP_FOR_219_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(220, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_220, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(220, s), p, o, m)
# define SIMDPP_PP_FOR_220_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(221, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_221, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(221, s), p, o, m)
# define SIMDPP_PP_FOR_221_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(222, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_222, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(222, s), p, o, m)
# define SIMDPP_PP_FOR_222_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(223, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_223, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(223, s), p, o, m)
# define SIMDPP_PP_FOR_223_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(224, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_224, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(224, s), p, o, m)
# define SIMDPP_PP_FOR_224_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(225, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_225, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(225, s), p, o, m)
# define SIMDPP_PP_FOR_225_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(226, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_226, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(226, s), p, o, m)
# define SIMDPP_PP_FOR_226_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(227, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_227, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(227, s), p, o, m)
# define SIMDPP_PP_FOR_227_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(228, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_228, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(228, s), p, o, m)
# define SIMDPP_PP_FOR_228_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(229, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_229, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(229, s), p, o, m)
# define SIMDPP_PP_FOR_229_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(230, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_230, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(230, s), p, o, m)
# define SIMDPP_PP_FOR_230_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(231, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_231, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(231, s), p, o, m)
# define SIMDPP_PP_FOR_231_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(232, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_232, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(232, s), p, o, m)
# define SIMDPP_PP_FOR_232_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(233, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_233, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(233, s), p, o, m)
# define SIMDPP_PP_FOR_233_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(234, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_234, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(234, s), p, o, m)
# define SIMDPP_PP_FOR_234_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(235, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_235, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(235, s), p, o, m)
# define SIMDPP_PP_FOR_235_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(236, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_236, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(236, s), p, o, m)
# define SIMDPP_PP_FOR_236_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(237, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_237, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(237, s), p, o, m)
# define SIMDPP_PP_FOR_237_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(238, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_238, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(238, s), p, o, m)
# define SIMDPP_PP_FOR_238_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(239, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_239, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(239, s), p, o, m)
# define SIMDPP_PP_FOR_239_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(240, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_240, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(240, s), p, o, m)
# define SIMDPP_PP_FOR_240_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(241, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_241, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(241, s), p, o, m)
# define SIMDPP_PP_FOR_241_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(242, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_242, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(242, s), p, o, m)
# define SIMDPP_PP_FOR_242_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(243, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_243, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(243, s), p, o, m)
# define SIMDPP_PP_FOR_243_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(244, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_244, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(244, s), p, o, m)
# define SIMDPP_PP_FOR_244_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(245, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_245, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(245, s), p, o, m)
# define SIMDPP_PP_FOR_245_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(246, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_246, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(246, s), p, o, m)
# define SIMDPP_PP_FOR_246_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(247, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_247, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(247, s), p, o, m)
# define SIMDPP_PP_FOR_247_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(248, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_248, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(248, s), p, o, m)
# define SIMDPP_PP_FOR_248_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(249, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_249, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(249, s), p, o, m)
# define SIMDPP_PP_FOR_249_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(250, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_250, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(250, s), p, o, m)
# define SIMDPP_PP_FOR_250_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(251, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_251, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(251, s), p, o, m)
# define SIMDPP_PP_FOR_251_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(252, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_252, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(252, s), p, o, m)
# define SIMDPP_PP_FOR_252_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(253, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_253, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(253, s), p, o, m)
# define SIMDPP_PP_FOR_253_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(254, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_254, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(254, s), p, o, m)
# define SIMDPP_PP_FOR_254_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(255, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_255, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(255, s), p, o, m)
# define SIMDPP_PP_FOR_255_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(256, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_256, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(256, s), p, o, m)
# define SIMDPP_PP_FOR_256_C(c, s, p, o, m) SIMDPP_PP_IIF(c, m, SIMDPP_PP_TUPLE_EAT_2)(257, s) SIMDPP_PP_IIF(c, SIMDPP_PP_FOR_257, SIMDPP_PP_TUPLE_EAT_4)(SIMDPP_PP_EXPR_IIF(c, o)(257, s), p, o, m)
#
# endif
